#!/usr/bin/perl
##################################################################
#DISCLAIMER OF WARRANTY
#
#Free of charge Software is provided on an "AS IS" basis,  without
#warranty of any kind, including without limitation the warranties
#of merchantability, fitness for a  particular  purpose  and  non-
#infringement.  The  entire risk as to the quality and performance
#of the Software is borne  by  you.   Should  the  Software  prove
#defective, you and not  ilink  assume the entire cost of any ser-
#vice and repair.  This  disclaimer  of  warranty  constitutes  an
#essential part of the agreement.
# 
#Even if parts of the disclaimer violates  legal  rights  of  some
#jurisdiction,  only  these  parts are invalid, but not the entire
#disclaimer.
##################################################################
 
use Time::Local;

sub invalidargs {
  printf "Usage : $0 <logfile(s)>\n";
  exit(0);
}

if (scalar @ARGV !=1) {
  invalidargs;
}
my $giventime;
my $millisecs;
my $reftime=timegm(0,0,0,1,0,2001);

my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;
my $thisday;

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime;
if ($year >=100){
  $year=$year-100+2000;
}
my $localhour = (localtime)[2]-$hour;

my $file = shift(@ARGV);
my $counter = '_readableTime';
my ($tmp) = $file ;
$counter++ while -e "$tmp$counter"; # don't overwrite anything
$tmp .= $counter;

open(FILE, "< $file") || die "Cannot read $file:$!";
open(TMP,"> $tmp") || die "Cannot write $tmp:$!";
while(<FILE>) {
    my $found=0;
    $giventime=0;
    $millisecs=0;
    $found = /^(-*\d+)(\.)(\d+)(:)/g;
    if ($found != 0) {
      $giventime=$1;
      $millisecs=$3;
    } else {
      print TMP $_;
    }
    if ($giventime !=0){
      my $difftime;
      $difftime=$reftime+$giventime;
      ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($difftime);
      if ($year >=100){
	$year=$year-100+2000;
      }
      $mon++;
      #print "difftime $sec sec,$min min,$hour h,$mday mday ,$mon mon,$year year,$wday wday,$yday yday\n";
      $thisday = (Sun,Mon,Tue,Wed,Thu,Fri,Sat)[$wday];
      $hour+=$localhour;
      if ($hour<10){
	$hour="0$hour";
      }
      if ($min<10){
	$min="0$min";
      }
      if ($sec<10){
	$sec="0$sec";
      }
      my $converted="[$thisday $mday.$mon. $year $hour:$min:$sec";
      print TMP "$converted.".$millisecs."]:".$';
    }
  }#while
close(TMP);
close(FILE);
#rename($tmp, $file) || die "Cannot rename $tmp to $file:$!";

